// 
//
#include "URL.h"

#include <string.h>
#include <ctype.h>
#include <iostream.h>
#include "Server.h"

//extern "C" {
	char* strstr_no_care(char* s1, char* s2);
//}

//
//  OK, I could right a better parser.
//

URL::URL( char *raw ) : full(0), host(0), port(80), path(0), dir(0), file(0)
{
   char *start;
   char *end;
   char *tmp;

/*   if ( (start = strstr(raw,"<a href"))  ||
        (start = strstr(raw,"<A HREF"))  || 
        (start = strstr(raw,"<img src")) ||
        (start = strstr(raw,"<IMG SRC"))) { */

	if ( (start = strstr_no_care(raw,"<a href")) ||
		(start = strstr_no_care(raw,"<img src"))) {
      start = strchr(start,'\"');
      if (start) start++;
   } else start = raw;

   if (!start) {
      full = strdup("");
      path = strdup("");
      host = strdup("");
      dir = strdup("");
      file = strdup("");
      return;
   }

   if ( (end = strchr(start,'\"')) ) *end = 0;
   if ( (tmp = strchr(start,'#')) ) *tmp = 0;   

   //
   //  The Full URL parsed from html
   //
   full = strdup(start);

   // 
   //  Do we have a host and port ?
   //
   if ( (tmp = strstr(start,"//")) ) {
      start = tmp + 2;
      host = strdup(start);
      if ( (tmp = strchr(host,'/')) ) *tmp = 0;
      if ( (tmp = strchr(host,':')) ) {
         if ( isdigit(tmp[1]) ) port = atoi(&tmp[1]);
         else port = 80;
         *tmp = 0;
      }
      start = strchr(start,'/');          
   }

   //
   //  This is the full path name of the file to get
   //
   if ( start ) path = strdup(start); 
   else path = strdup("/");

   //
   //  Pull out the directory and the filename
   //
   dir = strdup(path);  // alittle wasteful
   if ( strchr(dir,'/') ) {
      start = dir;
      while ( (tmp = strchr(start+1,'/')) != 0 ) { start = tmp; } 
      file = strdup(++start);
      *start = 0;
   } else {
      file = strdup(path);
      *dir = 0;
   }

   if ( strlen(file) == 0 ) {
      delete file;
      file = strdup("index.html");
   } 
      
   if ( !host ) {
      host = strdup(Server::CurrentServer());
      port = Server::CurrentPort();
   }

#ifdef DEBUG
cout << "Full: '" << full << "'" << endl;
cout << "Path: '" << path << "'" << endl;
cout << "Host: '" << host << "'" << endl;
cout << "Port: " << port << endl;
cout << "Dir: '" << dir << "'" << endl;
cout << "File: '" << file << "'" << endl;
#endif
}

URL::URL( char *raw ,char * par_dir) : full(0), host(0), port(80), path(0), dir(0), file(0)
{
   char *start;
   char *end;
   char *tmp;
	char *xdir;
		char dirname[256];

/*   if ( (start = strstr(raw,"<a href"))  ||
        (start = strstr(raw,"<A HREF"))  || 
        (start = strstr(raw,"<img src")) ||
        (start = strstr(raw,"<IMG SRC"))) { */

	if ( (start = strstr_no_care(raw,"<a href")) ||
		(start = strstr_no_care(raw,"<img src"))) {
      start = strchr(start,'\"');
      if (start) start++;
   } else start = raw;

   if (!start) {
      full = strdup("");
      path = strdup("");
      host = strdup("");
      dir = strdup("");
      file = strdup("");
      return;
   }

   if ( (end = strchr(start,'\"')) ) *end = 0;
   if ( (tmp = strchr(start,'#')) ) *tmp = 0;   

   //
   //  The Full URL parsed from html
   //
   full = strdup(start);

   // 
   //  Do we have a host and port ?
   //
   if ( (tmp = strstr(start,"//")) ) {
      start = tmp + 2;
      host = strdup(start);
      if ( (tmp = strchr(host,'/')) ) *tmp = 0;
      if ( (tmp = strchr(host,':')) ) {
         if ( isdigit(tmp[1]) ) port = atoi(&tmp[1]);
         else port = 80;
         *tmp = 0;
      }
      start = strchr(start,'/');          
   }

   //
   //  This is the full path name of the file to get
   //
   if ( start ) path = strdup(start); 
   else path = strdup("/");

   //
   //  Pull out the directory and the filename
   //
   xdir = strdup(path);  // alittle wasteful
   if ( strchr(xdir,'/') ) {
      start = xdir;
      while ( (tmp = strchr(start+1,'/')) != 0 ) { start = tmp; } 
      file = strdup(++start);
      *start = 0;
   } else {
      file = strdup(path);
      *xdir = 0;
   }
	if (*xdir != '/') { 
		dirname[0] = 0;
		strcat(dirname, par_dir);
		strcat(dirname, xdir);
		dir = strdup(dirname);
	}
	else dir = xdir;

   if ( strlen(file) == 0 ) {
      delete file;
      file = strdup("index.html");
   } 
      
   if ( !host ) {
      host = strdup(Server::CurrentServer());
      port = Server::CurrentPort();
   }

#ifdef DEBUG
cout << "Full: '" << full << "'" << endl;
cout << "Path: '" << path << "'" << endl;
cout << "Host: '" << host << "'" << endl;
cout << "Port: " << port << endl;
cout << "Dir: '" << dir << "'" << endl;
cout << "File: '" << file << "'" << endl;
#endif
}

URL::URL( URL *u )
{
   full = strdup(u->full);
   path = strdup(u->path);
   host = strdup(u->host);
   dir  = strdup(u->dir);
   file = strdup(u->file);
}

URL::~URL()
{
   delete full;
   delete path;
   delete host;
   delete dir;
   delete file;
}

int URL::HasURL( char *text )
{
/*   if ( !strstr(text,"<a href")  && !strstr(text,"<A HREF") && 
        !strstr(text,"<img src") && !strstr(text,"<IMG SRC")) return 0; */
   if ( !strstr_no_care(text,"<a href")   && 
        !strstr_no_care(text,"<img src") ) return 0; 
   return 1;
}

int operator==( const URL& l, const URL& r )
{
   return ( !strcmp(l.path,r.path) );
}


